using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Web.Script.Serialization;
using System.Collections.Generic;
using System.Xml.Serialization;

namespace Jeffz.JavaScriptConvertDemo
{
	public class Boy
	{
		public string Name;

		public Girl Girlfriend;
	}

	public class Girl
	{
		public string Name;

		public Boy Boyfriend;

		[XmlIgnore]
		public bool __HasClientBoyfriend = false;
	}

	public class BoyConverter : JavaScriptConverter
	{
		protected override Type[] SupportedTypes
		{
			get
			{
				return new Type[] { typeof(Boy) };
			}
		}

		public override object Deserialize(string s, Type t)
		{
			if (t != typeof(Boy))
			{
				throw new ArgumentException();
			}

			Boy boy = (Boy)base.Deserialize(s, t);

			if (boy.Girlfriend != null && boy.Girlfriend.__HasClientBoyfriend)
			{
				boy.Girlfriend.Boyfriend = boy;
			}

			return boy;
		}

		public override string Serialize(object o)
		{
			Boy boy = o as Boy;

			if (boy == null)
			{
				throw new ArgumentException();
			}

			string result = 
@"function() 
{ 
    var boy = 
    {
        Name : " + JavaScriptObjectSerializer.Serialize(boy.Name) + @", 
        Girlfriend :
        {
            Name : " + JavaScriptObjectSerializer.Serialize(boy.Girlfriend.Name) + @"
        }
    };

    boy.Girlfriend.Boyfriend = boy;
    return boy;
}.call()";

			return result;
		}
	}

}